/**
 *
 */
package de.intevation.gnv.geobackend.base;

import java.util.Date;


/**
 * Interface which provides the Methods for Accessing
 * the Data of an ResultEntry
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public interface Result {
  
    /**
     * Returns the ResultDescriptor which provides the
     * ResultMetadatse
     * @return the ResultDescriptor
     */
    public ResultDescriptor getResultDescriptor();
    
    /**
     * Returns the Columnvalue as a String
     * @param columnName the Name of the column
     * @return the Columnvalue as a String
     */
    public String getString(String columnName);
    
    /**
     * Returns the Columnvalue as a Date
     * @param columnName the Name of the column
     * @return the Columnvalue as a Date
     */
    public Date getDate(String columnName);
    
    /**
     * Returns the Columnvalue as a Integer
     * @param columnName the Name of the column
     * @return the Columnvalue as a Integer
     */
    public Integer getInteger(String columnName);

    /**
     * Returns the Columnvalue as a Float
     * @param columnName the Name of the column
     * @return the Columnvalue as a Float
     */
    public Float getFloat(String columnName);
    
    /**
     * Returns the Columnvalue as a Double
     * @param columnName the Name of the column
     * @return the Columnvalue as a Double
     */
    public Double getDouble(String columnName);
    
    /**
     * Returns the Columnvalue as a Object
     * @param columnName the Name of the column
     * @return the Columnvalue as a Object
     */
    public Object getObject(String columnName);
    
    /**
     * Adds an new Coumnvalue to the Result.
     * @param columnName the Name of the Column
     * @param value the Value of the Column
     */
    public void addColumnValue(String columnName, Object value);
}
